-- MINIMAP SCRIPT BY ENGIN33R! --
-- All rights reserved. --
-- Redistributing this script as yours is strictly prohibited. --
-- You suck if you do that ^^^^ --

-- The script may take some time to draw the minimap, but don't worry. --

dofile("sys/lua/basicfuncs.lua")

images = {
	[1] = "gfx/minimap2px.png",
	[2] = "gfx/minimap4px.png",
	[3] = "gfx/minimap6px.png",
	-- to add your own write using this template:
	-- [4] = "gfx/YOURFILENAME.EXTENSION",
	-- e.g. [4] = "gfx/minimap8px.png",
}

minimapmode=3 -- Mode 1 - show to all players, mode 2 - show on all players' HUD, mode 3 - show on admins' HUD

usedimg=images[2]
mscale=2

admins = {7749}

mapx=96
mapy=96

minimapbase=0
object=1
objimage=initArray2(2048,0)

minimapdrawn=false

mappos=doublearray(2,2048,0)

-- Definition of map positions --
curxpos=0
curypos=0

function initNewTiles()
	mappos[1][0]=(mapx-math.floor((map("xsize")/2)))
	mappos[2][0]=(mapy-math.floor((map("ysize")/2)))
	mappos[1][map("xsize")]=(mapx+math.floor((map("xsize")/2)))
	mappos[2][map("ysize")]=(mapy+math.floor((map("ysize")/2)))
	for xp=1,map("xsize")+1 do
		if (xp>0 and xp<map("xsize")+1) then
			mappos[1][xp]=mappos[1][xp-1]+mscale*2
		end
	end
	for yp=1,map("ysize")+1 do
		if (yp>0 and yp<map("xsize")+1) then
			mappos[2][yp]=mappos[2][yp-1]+mscale*2
		end
	end
end

initNewTiles()

function findAdmins()
	for id=1,32 do
		if (contains(admins,player(id,"usgn"))) then
			return id
		end
	end
end

function drawMinimap()
	if (minimapmode==1) then
		for objects=1,object do
			freeimage(objimage[objects])
		end
		object=1
		freeimage(minimapbase)
		minimapbase=image(usedimg,mapx,mapy,3)
		imagescale(minimapbase,map("xsize")+1,map("ysize")+1)
		imagepos(minimapbase,mappos[1][0]+map("xsize")*mscale,mappos[2][0]+map("ysize")*mscale,0)
		imagecolor(minimapbase,37,37,37)
		imagealpha(minimapbase,0.5)
		initMiniChars()
		minimapdrawn=true
	elseif (minimapmode==2) then
		for objects=1,object do
			freeimage(objimage[objects])
		end
		object=1
		freeimage(minimapbase)
		minimapbase=image(usedimg,mapx,mapy,2)
		imagescale(minimapbase,map("xsize")+1,map("ysize")+1)
		imagepos(minimapbase,mappos[1][0]+map("xsize")*mscale,mappos[2][0]+map("ysize")*mscale,0)
		imagecolor(minimapbase,37,37,37)
		imagealpha(minimapbase,0.5)
		initMiniChars()
		minimapdrawn=true
	elseif (minimapmode==3) then
		for objects=1,object do
			freeimage(objimage[objects])
		end
		object=1
		freeimage(minimapbase)
		minimapbase=image(usedimg,mapx,mapy,2,findAdmins())
		imagescale(minimapbase,map("xsize")+1,map("ysize")+1)
		imagepos(minimapbase,mappos[1][0]+map("xsize")*mscale,mappos[2][0]+map("ysize")*mscale,0)
		imagecolor(minimapbase,37,37,37)
		imagealpha(minimapbase,0.5)
		initMiniChars()
		minimapdrawn=true
	end
end

addhook("say","initMinimap")
function initMinimap(id,t)
    if (t=="!initmap" and contains(admins,player(id,"usgn")) and not minimapdrawn) then
		drawMinimap()
    end
	if (t:sub(1,9)=="!mapscale" and contains(admins,player(id,"usgn")) and minimapdrawn) then
		local scale=tonumber(t:sub(10))
		if (scale>=1 and scale<=#images) then
			usedimg=images[scale]
			mscale=scale
			minimapdrawn=false
			initNewTiles()
			drawMinimap()
		end
	end
end

function drawObject(x,y)
	if (tile(x,y,"property")==1 or tile(x,y,"property")==3) then
		if (minimapmode==1) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),3)
		elseif (minimapmode==2) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2)
		elseif (minimapmode==3) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2,findAdmins())
		end
		imagepos(objimage[object],mappos[1][x],mappos[2][y],0)
		imagecolor(objimage[object],255,255,255)
		imagealpha(objimage[object],0.5)
		object=object+1
	end
	if (tile(x,y,"property")==2 or tile(x,y,"property")==4) then
		if (minimapmode==1) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),3)
		elseif (minimapmode==2) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2)
		elseif (minimapmode==3) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2,findAdmins())
		end
		imagepos(objimage[object],mappos[1][x],mappos[2][y],0)
		imagecolor(objimage[object],94,94,94)
		imagealpha(objimage[object],0.5)
		object=object+1
	end
	if (tile(x,y,"property")==14) then
		if (minimapmode==1) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),3)
		elseif (minimapmode==2) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2)
		elseif (minimapmode==3) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2,findAdmins())
		end
		imagepos(objimage[object],mappos[1][x],mappos[2][y],0)
		imagecolor(objimage[object],0,75,112)
		imagealpha(objimage[object],0.5)
		object=object+1
	end
	if (tile(x,y,"property")>=50) then
		if (minimapmode==1) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),3)
		elseif (minimapmode==2) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2)
		elseif (minimapmode==3) then
			objimage[object]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2,findAdmins())
		end
		imagepos(objimage[object],mappos[1][x],mappos[2][y],0)
		imagecolor(objimage[object],191,0,0)
		imagealpha(objimage[object],0.5)
		object=object+1
	end
end

playerimg=initArray2(32,0)

function drawPlayers()
	for id=1,32 do
		if (player(id,"exists") and player(id,"team")>0 and minimapdrawn) then
			freeimage(playerimg[id])
			if (minimapmode==1) then
				playerimg[id]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),3)
			elseif (minimapmode==2) then
				playerimg[id]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2)
			elseif (minimapmode==3) then
				playerimg[id]=image(usedimg,128-(map("xsize")/2),128-(map("ysize")/2),2,findAdmins())
			end
			imagepos(playerimg[id],mappos[1][player(id,"tilex")],mappos[2][player(id,"tiley")],0)
			imagealpha(playerimg[id],0.5)
			if (player(id,"team")==1) then
				imagecolor(playerimg[id],255,0,0)
			elseif (player(id,"team")==2) then
				imagecolor(playerimg[id],0,0,255)
			end
		end
		if (not player(id,"exists")) then
			freeimage(playerimg[id])
		end
	end
end

addhook("second","players")
function players()
	drawPlayers()
end

function initMiniChars()
	for x=0,map("xsize") do
		for y=0,map("ysize") do
			drawObject(x,y)
		end
	end
end

addhook("startround","roundstartfix")
function roundstartfix()
	if (minimapdrawn) then
		drawMinimap()
	end
end